<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Time.php 3428 2005-07-04 15:58:31Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage Priority
 */
class MAX_Maintenance_Priority_Constraint_Time extends MAX_Maintenance_Priority_Constraint 
{
    function MAX_Maintenance_Priority_Constraint_Time($aOption)
    {
        parent::MAX_Maintenance_Priority_Constraint($aOption);
    }
    
    /**
    * Express delivery limitations to be in terms of when  
    * not to deliver
    * @return void
    */
    function calculateNonDeliveryRestrictions() {
        $hours = range(0,23);
        
        // change to be in terms of !=
        if ($this->comparison == '==') {
            foreach ($this->data as $val) {
                $key = array_search($val, $hours);
                unset($hours[$key]);
            }
            $this->data = $hours;
            $this->comparison = $this->getNonDeliveryOperator($this->comparison);
        }
    }
    
    function minutesPerTimePeriod() {
       return 60;
    }
    
   /**
    * Method to valudate a given date against array of hours not
    * to deliver in
    *
    * @param object $date PEAR::Date object representing date/time being tested
    * @return bool true if match is found in $this->data
    */
    function testInterval($oDate)
    {
        return (in_array($oDate->getHour(), $this->data)) ? 1 : 0;
    }
}

?>
